pcl::LabeledEuclideanClusterExtraction< PointT > Class Template Reference
Module segmentation

LabeledEuclideanClusterExtraction represents a segmentation class for cluster extraction in an Euclidean sense, with label info. More...

`#include <pcl/segmentation/extract_labeled_clusters.h>`

Inheritance diagram for pcl::LabeledEuclideanClusterExtraction< PointT >:

## Public Types

typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef pcl::search::Search< PointT > | KdTree
typedef pcl::search::Search< PointT >::Ptr | KdTreePtr
typedef PointIndices::Ptr | PointIndicesPtr
typedef PointIndices::ConstPtr | PointIndicesConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| LabeledEuclideanClusterExtraction ()
| Empty constructor. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
void | setClusterTolerance (double tolerance)
| Set the spatial cluster tolerance as a measure in the L2 Euclidean space. More...
double | getClusterTolerance () const
| Get the spatial cluster tolerance as a measure in the L2 Euclidean space. More...
void | setMinClusterSize (int min_cluster_size)
| Set the minimum number of points that a cluster needs to contain in order to be considered valid. More...
int | getMinClusterSize () const
| Get the minimum number of points that a cluster needs to contain in order to be considered valid. More...
void | setMaxClusterSize (int max_cluster_size)
| Set the maximum number of points that a cluster needs to contain in order to be considered valid. More...
int | getMaxClusterSize () const
| Get the maximum number of points that a cluster needs to contain in order to be considered valid. More...
void | setMaxLabels (unsigned int max_label)
| Set the maximum number of labels in the cloud. More...
unsigned int | getMaxLabels () const
| Get the maximum number of labels. More...
void | extract (std::vector< std::vector< PointIndices > > &labeled_clusters)
| Cluster extraction in a PointCloud given by <setInputCloud (), setIndices ()> More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual std::string | getClassName () const
| Class getName method. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | cluster_tolerance_
| The spatial cluster tolerance as a measure in the L2 Euclidean space. More...
int | min_pts_per_cluster_
| The minimum number of points that a cluster needs to contain in order to be considered valid (default = 1). More...
int | max_pts_per_cluster_
| The maximum number of points that a cluster needs to contain in order to be considered valid (default = MAXINT). More...
unsigned int | max_label_
| The maximum number of labels we can find in this pointcloud (default = MAXINT) More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::LabeledEuclideanClusterExtraction< PointT >

LabeledEuclideanClusterExtraction represents a segmentation class for cluster extraction in an Euclidean sense, with label info.

Author
  Koen Buys

Definition at line 71 of file extract_labeled_clusters.h.

## Member Typedef Documentation

template<typename PointT >

typedef pcl::search::Search<PointT> pcl::LabeledEuclideanClusterExtraction< PointT >::KdTree

Definition at line 80 of file extract_labeled_clusters.h.

template<typename PointT >

typedef pcl::search::Search<PointT>::Ptr pcl::LabeledEuclideanClusterExtraction< PointT >::KdTreePtr

Definition at line 81 of file extract_labeled_clusters.h.

template<typename PointT >

typedef pcl::PointCloud<PointT> pcl::LabeledEuclideanClusterExtraction< PointT >::PointCloud

Definition at line 76 of file extract_labeled_clusters.h.

template<typename PointT >

typedef PointCloud::ConstPtr pcl::LabeledEuclideanClusterExtraction< PointT >::PointCloudConstPtr

Definition at line 78 of file extract_labeled_clusters.h.

template<typename PointT >

typedef PointCloud::Ptr pcl::LabeledEuclideanClusterExtraction< PointT >::PointCloudPtr

Definition at line 77 of file extract_labeled_clusters.h.

template<typename PointT >

typedef PointIndices::ConstPtr pcl::LabeledEuclideanClusterExtraction< PointT >::PointIndicesConstPtr

Definition at line 84 of file extract_labeled_clusters.h.

template<typename PointT >

typedef PointIndices::Ptr pcl::LabeledEuclideanClusterExtraction< PointT >::PointIndicesPtr

Definition at line 83 of file extract_labeled_clusters.h.

## Constructor & Destructor Documentation

template<typename PointT >

pcl::LabeledEuclideanClusterExtraction< PointT >::LabeledEuclideanClusterExtraction | ( |  | ) |

inline

Empty constructor.

Definition at line 88 of file extract_labeled_clusters.h.

## Member Function Documentation

template<typename PointT >

void pcl::LabeledEuclideanClusterExtraction< PointT >::extract | ( | std::vector< std::vector< PointIndices > > & | labeled_clusters | ) |

Cluster extraction in a PointCloud given by <setInputCloud (), setIndices ()>

Parameters

  [out] | labeled_clusters | the resultant point clusters

Definition at line 123 of file extract_labeled_clusters.hpp.

References pcl::comparePointClusters(), and pcl::extractLabeledEuclideanClusters().

Referenced by pcl::LabeledEuclideanClusterExtraction< PointT >::getMaxLabels().

template<typename PointT >

virtual std::string pcl::LabeledEuclideanClusterExtraction< PointT >::getClassName | ( |  | ) | const

inline protected virtual

Class getName method.

Definition at line 175 of file extract_labeled_clusters.h.

template<typename PointT >

double pcl::LabeledEuclideanClusterExtraction< PointT >::getClusterTolerance | ( |  | ) | const

inline

Get the spatial cluster tolerance as a measure in the L2 Euclidean space.

Definition at line 114 of file extract_labeled_clusters.h.

References pcl::LabeledEuclideanClusterExtraction< PointT >::cluster_tolerance_.

template<typename PointT >

int pcl::LabeledEuclideanClusterExtraction< PointT >::getMaxClusterSize | ( |  | ) | const

inline

Get the maximum number of points that a cluster needs to contain in order to be considered valid.

Definition at line 134 of file extract_labeled_clusters.h.

References pcl::LabeledEuclideanClusterExtraction< PointT >::max_pts_per_cluster_.

template<typename PointT >

unsigned int pcl::LabeledEuclideanClusterExtraction< PointT >::getMaxLabels | ( |  | ) | const

inline

Get the maximum number of labels.

Definition at line 144 of file extract_labeled_clusters.h.

References pcl::PCLBase< PointT >::deinitCompute(), pcl::LabeledEuclideanClusterExtraction< PointT >::extract(), pcl::PCLBase< PointT >::indices_, pcl::PCLBase< PointT >::initCompute(), pcl::PCLBase< PointT >::input_, and pcl::LabeledEuclideanClusterExtraction< PointT >::max_label_.

template<typename PointT >

int pcl::LabeledEuclideanClusterExtraction< PointT >::getMinClusterSize | ( |  | ) | const

inline

Get the minimum number of points that a cluster needs to contain in order to be considered valid.

Definition at line 124 of file extract_labeled_clusters.h.

References pcl::LabeledEuclideanClusterExtraction< PointT >::min_pts_per_cluster_.

template<typename PointT >

KdTreePtr pcl::LabeledEuclideanClusterExtraction< PointT >::getSearchMethod | ( |  | ) | const

inline

Get a pointer to the search method used.

Definition at line 104 of file extract_labeled_clusters.h.

References pcl::LabeledEuclideanClusterExtraction< PointT >::tree_.

template<typename PointT >

void pcl::LabeledEuclideanClusterExtraction< PointT >::setClusterTolerance | ( | double | tolerance | ) |

inline

Set the spatial cluster tolerance as a measure in the L2 Euclidean space.

Parameters

  [in] | tolerance | the spatial cluster tolerance as a measure in the L2 Euclidean space

Definition at line 110 of file extract_labeled_clusters.h.

References pcl::LabeledEuclideanClusterExtraction< PointT >::cluster_tolerance_.

template<typename PointT >

void pcl::LabeledEuclideanClusterExtraction< PointT >::setMaxClusterSize | ( | int | max_cluster_size | ) |

inline

Set the maximum number of points that a cluster needs to contain in order to be considered valid.

Parameters

  [in] | max_cluster_size | the maximum cluster size

Definition at line 130 of file extract_labeled_clusters.h.

References pcl::LabeledEuclideanClusterExtraction< PointT >::max_pts_per_cluster_.

template<typename PointT >

void pcl::LabeledEuclideanClusterExtraction< PointT >::setMaxLabels | ( | unsigned int | max_label | ) |

inline

Set the maximum number of labels in the cloud.

Parameters

  [in] | max_label | the maximum

Definition at line 140 of file extract_labeled_clusters.h.

References pcl::LabeledEuclideanClusterExtraction< PointT >::max_label_.

template<typename PointT >

void pcl::LabeledEuclideanClusterExtraction< PointT >::setMinClusterSize | ( | int | min_cluster_size | ) |

inline

Set the minimum number of points that a cluster needs to contain in order to be considered valid.

Parameters

  [in] | min_cluster_size | the minimum cluster size

Definition at line 120 of file extract_labeled_clusters.h.

References pcl::LabeledEuclideanClusterExtraction< PointT >::min_pts_per_cluster_.

template<typename PointT >

void pcl::LabeledEuclideanClusterExtraction< PointT >::setSearchMethod | ( | const KdTreePtr & | tree | ) |

inline

Provide a pointer to the search object.

Parameters

  [in] | tree | a pointer to the spatial search object.

Definition at line 100 of file extract_labeled_clusters.h.

References pcl::LabeledEuclideanClusterExtraction< PointT >::tree_.

## Member Data Documentation

template<typename PointT >

double pcl::LabeledEuclideanClusterExtraction< PointT >::cluster_tolerance_

protected

The spatial cluster tolerance as a measure in the L2 Euclidean space.

Definition at line 163 of file extract_labeled_clusters.h.

Referenced by pcl::LabeledEuclideanClusterExtraction< PointT >::getClusterTolerance(), and pcl::LabeledEuclideanClusterExtraction< PointT >::setClusterTolerance().

template<typename PointT >

unsigned int pcl::LabeledEuclideanClusterExtraction< PointT >::max_label_

protected

The maximum number of labels we can find in this pointcloud (default = MAXINT)

Definition at line 172 of file extract_labeled_clusters.h.

Referenced by pcl::LabeledEuclideanClusterExtraction< PointT >::getMaxLabels(), and pcl::LabeledEuclideanClusterExtraction< PointT >::setMaxLabels().

template<typename PointT >

int pcl::LabeledEuclideanClusterExtraction< PointT >::max_pts_per_cluster_

protected

The maximum number of points that a cluster needs to contain in order to be considered valid (default = MAXINT).

Definition at line 169 of file extract_labeled_clusters.h.

Referenced by pcl::LabeledEuclideanClusterExtraction< PointT >::getMaxClusterSize(), and pcl::LabeledEuclideanClusterExtraction< PointT >::setMaxClusterSize().

template<typename PointT >

int pcl::LabeledEuclideanClusterExtraction< PointT >::min_pts_per_cluster_

protected

The minimum number of points that a cluster needs to contain in order to be considered valid (default = 1).

Definition at line 166 of file extract_labeled_clusters.h.

Referenced by pcl::LabeledEuclideanClusterExtraction< PointT >::getMinClusterSize(), and pcl::LabeledEuclideanClusterExtraction< PointT >::setMinClusterSize().

template<typename PointT >

KdTreePtr pcl::LabeledEuclideanClusterExtraction< PointT >::tree_

protected

A pointer to the spatial search object.

Definition at line 160 of file extract_labeled_clusters.h.

Referenced by pcl::LabeledEuclideanClusterExtraction< PointT >::getSearchMethod(), and pcl::LabeledEuclideanClusterExtraction< PointT >::setSearchMethod().

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/segmentation/include/pcl/segmentation/extract_labeled_clusters.h
- /build/pcl-0nnAvv/pcl-1.7.2/segmentation/include/pcl/segmentation/impl/extract_labeled_clusters.hpp